<?php
 /*
   Limph Is Monitoring Pingable Hosts
   Copyright (C) 2006 Jonathan Ciesla
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
  */
require_once("config.php");
require_once("functionlib.php");
session_start();
favicon();

$link = dbms_connect($dbhost, $dbuser, $dbpass, $dbname);

$user_id = dbms_escape_string($_SESSION['limphid']);

$admin_level =$_SESSION['limphadmin'];
authentication($admin_level,1);
  
echo "<link rel=stylesheet href=css.php>";
echo "<title>$sitetitle</title>";
echo "<h1>$sitetitle</h1>";

$optimize = $_POST['optimize'];
if($optimize=="yes"){
  if($dbtype=="my"){
    $query = "SHOW TABLES";
    $result = dbms_query($query);
    while($tables = dbms_fetch_array($result, "NUM")){
      $tab = $tables[0];
      $query = "OPTIMIZE TABLE `$tab`;";
      $result2 = dbms_query($query);
    };
    dbms_free_result($result);
  };
  if($dbtype=="pg"){
    $query = "VACUUM FULL;";
    $result = dbms_query($query);
  };
};

$update = $_POST['update'];
if($update=="yes"){
  $notify=dbms_escape_string($_POST['notify']);
  $address=dbms_escape_string($_POST['address']);
  $statuspublic=dbms_escape_string($_POST['statuspublic']);
  
  $autoupdateip=$_POST['autoupdateip'];
  $textsize = $_POST['textsize'];
  $tabletextsize = $_POST['tabletextsize'];
  

  $query = "UPDATE universal set notify='$notify',address='$address',autoupdateip='$autoupdateip',textsize='$textsize',tabletextsize='$tabletextsize',status_public='$statuspublic';";
  $result = dbms_query($query, $link);

  echo "Configuration updated.";
};

echo "<h2>Global Configuration</h2>";

echo "<table border=1 align=center>";
echo "<tr><th>On/Off</th><th>Email Notification Address</th><th>Auto-Update IPs</th><th>Text Size</th><th>Table Text</th><th>Public Status</th></tr>";
$query = "SELECT notify,address,autoupdateip,textsize,tabletextsize,status_public FROM universal";
$result = dbms_query($query);
while($line = dbms_fetch_array($result, "ASSOC")){
  echo "<tr>";
  echo "<form action=univ.php method=post>";
  echo "<td>";
  if($line['notify']=="0"){$flagzero="checked";}else{$flagzero="";};
  if($line['notify']=="1"){$flagone="checked";}else{$flagone="";};
  echo "On<input type=radio name=notify value=1 $flagone />";
  echo "Off<input type=radio name=notify value=0 $flagzero />";
  echo "</td>";
  
  echo "<td>";
  echo "<input type=text size=30 name=address value=\"{$line['address']}\">";
  echo "</td>";

  echo "<td align=center>";
  if($line['autoupdateip']=="0"){$flagautozero="checked";}else{$flagautozero="";};
  if($line['autoupdateip']=="1"){$flagautoone="checked";}else{$flagautoone="";};
  echo "On<input type=radio name=autoupdateip value=1 $flagautoone />";
  echo "Off<input type=radio name=autoupdateip value=0 $flagautozero />";
  echo "</td>";

  $sizearray = array("xx-small", "x-small", "small", "medium", "large", "x-large", "xx-large");
  echo "<td>";
  echo "<select name=textsize>";
  foreach($sizearray as $size){
    if($size==$line['textsize']){$flag="selected";}else{$flag="";};
    echo "<option value=\"$size\" $flag>$size";
  };
  echo "</select>";
  echo "</td>";

  echo "<td>";
  echo "<select name=tabletextsize>";
  foreach($sizearray as $size){
    if($size==$line['tabletextsize']){$flag="selected";}else{$flag="";};
    echo "<option value=\"$size\" $flag>$size";
  };
  echo "</select>";
  echo "</td>";

  echo "<td>";
  if($line['status_public']=="0"){$flagzero="checked";}else{$flagzero="";};
  if($line['status_public']=="1"){$flagone="checked";}else{$flagone="";};
  echo "Enabled<input type=radio name=statuspublic value=1 $flagone />";
  echo "Disabled<input type=radio name=statuspublic value=0 $flagzero />";
  echo "</td>";

  echo "<td>";
  echo "<input type=hidden name=update value=yes>";
  echo "<input type=submit value=Change>";
  echo "</td>";

  echo "</form>";
  echo "</tr>";
};
echo "</table>";
dbms_free_result($result);

echo "<br />";
echo "<form action=upgrade.php method=post>";
echo "<input type=submit value=\"Check/Upgrade DB\" />";
echo "</form>";

echo "<br />";
echo "<form action=univ.php method=post>";
echo "<input type=hidden name=optimize value=yes>";
if($dbtype=="my"){
echo "<input type=submit value=\"Optimize Database\">";
 };
if($dbtype=="pg"){
echo "<input type=submit value=\"Vacuum(FULL) Database\">";
 };
echo "</form>";
echo "<br />";

echo "<form action=univ.php method=post>";
echo "<input type=hidden name=verip value=yes>";
echo "<input type=submit value=\"Verify IP Addresses\">";
echo "</form>";
echo "<br />";

echo "<table border=1 align=center>";
echo "<tr><td>";
echo "<form action=discovery.php method=post>";
echo "<input type=submit value=\"Host Discovery\">";
echo "</form>";
echo "</td><td>";
echo "<form action=ungrouped.php method=post>";
echo "<input type=submit value=\"View Ungrouped Hosts\" />";
echo "</form>";
echo "</td></tr>";
echo "</table>";

$verip = $_POST['verip'];
$updateip = $_POST['updateip'];
if($updateip=="yes"){
  $num = $_POST['num'];
  $newip = $_POST['newip'];
  
  $query = "UPDATE hosts SET ip='$newip' WHERE number = '$num';";
  $result = dbms_query($query);

  $verip = "yes";
 };

if($verip=="yes"){
  $query = "SELECT number,ip,name FROM hosts;";
  $result = dbms_query($query);
  echo "<table align=center border=1>";
  echo "<tr><th>Hostname</th><th>Current IP</th><th>DNS result</th><th>Update</th></tr>";
  while($line = dbms_fetch_array($result, "NUM")){
    $newip = dbms_escape_string(gethostbyname($line[2]));
    if($newip!=$line[1]){
      echo "<tr>";
      echo "<td>{$line['2']}</td>";
      echo "<td>{$line['1']}</td>";
      echo "<td>$newip</td>";
      echo "<td>";
      echo "<form action=univ.php method=post>";
      echo "<input type=hidden name=updateip value=yes>";
      echo "<input type=hidden name=num value=\"{$line['0']}\">";
      echo "<input type=hidden name=newip value=\"$newip\">";
      echo "<input type=submit value=Update>";
      echo "</form>";
      echo "</td>";
    };    
  };
  echo "</table>";
  dbms_free_result($result);
 };

dbms_close($link);

echo "<form action=index.php method=post>";
echo "<input type=submit value=Back />";
echo "</form>";
?>