<?php
 /*
   Limph Is Monitoring Pingable Hosts
   Copyright (C) 2006 Jonathan Ciesla
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
  */
require_once("config.php");
require_once("functionlib.php");
session_start();
favicon();

$link = dbms_connect($dbhost, $dbuser, $dbpass, $dbname);

authentication(0,0);

echo "<link rel=stylesheet href=css.php>";
echo "<title>Limph: $sitetitle</title>";
echo "<h3>Limph: $sitetitle</h3>";

$number = $_POST['host'];
$query = "SELECT name,type,port FROM hosts WHERE number = '$number';";
$result = dbms_query($query);
$line = dbms_fetch_array($result, "NUM");
dbms_free_result($result);

$hostname = $line[0];
$type = $line[1];
$port = $line[2];

//display host info
$displaystring = "<h2> Notification group for ";
$displaystring .= "$hostname - $type";
if($type=="tcp"){ $displaystring .= " - $port"; };
$displaystring .= "</h2>";
echo $displaystring;

$action = dbms_escape_string($_POST['action']);

if($action=="remove"){
  foreach($_POST['users'] as $user){
    $query = "DELETE FROM host_notif WHERE host = '$number' AND user = '$user';";
    $result = dbms_query($query);
  };
 };

if($action=="allocate"){
  foreach($_POST['users'] as $user){
    $query = "SELECT number FROM host_notif ORDER BY number DESC LIMIT 1;";
    $result = dbms_query($query);
    $line = dbms_fetch_array($result, "NUM");
    $notif = $line[0];
    $notif++;
    dbms_free_result($result);
    $query = "INSERT host_notif SET number = '$notif',host = '$number',user = '$user';";
    $result = dbms_query($query);
  };
 };

//table
echo "<table border=1 align=center cellpadding=2>";
echo "<tr><td valign=top>";
//left side users in host group
echo "<form action=host_notif.php method=post>";
echo "<input type=hidden name=action value=remove />";
$query = "SELECT number,user FROM host_notif WHERE host = '$number' ORDER BY number ASC;";
$result = dbms_query($query);
echo "List of allocated names<br />";
echo "<select name=users[] multiple=yes size=10 />";
while($line = dbms_fetch_array($result, "NUM")){
  $query1 = "SELECT id FROM users WHERE number = '{$line[1]}';";
  $result1 = dbms_query($query1);
  $line1 = dbms_fetch_array($result1, "NUM");
  dbms_free_result($result1);
  echo "<option value={$line[1]}>{$line1[0]}";
  dbms_free_result($result1);
 };
echo "</select>";
dbms_free_result($result);

//submit to remove
echo "</td><td valign=center>";
echo "<input type=hidden name=host value=$number>";
echo "<input type=submit value=\">\" />";
echo "</form>";

echo "<br /><br /><br /><br />";

//submit to add
echo "<form action=host_notif.php method=post>";
echo "<input type=hidden name=host value=$number>";
echo "<input type=submit value=\"<\" />";

//right side available users not in host group
echo "</td><td valign=top>";
echo "<input type=hidden name=action value=allocate />";
echo  "List of available names<br />";
echo "<select name=users[] multiple=yes size=10 />";
$query = "SELECT number,id FROM users ORDER BY id ASC;";
$result = dbms_query($query);
while($line = dbms_fetch_array($result, "NUM")){
  //check against allocated for this host
  $query2 = "SELECT COUNT(number) FROM host_notif WHERE host = '$number' AND user = '{$line[0]}';";
  $result2 = dbms_query($query2);
  $line2 = dbms_fetch_array($result2, "NUM");
  dbms_free_result($result2);
  if($line2[0]==0){
    echo "<option value={$line[0]}>{$line[1]}";
  };
  dbms_free_result($result1);
 };
echo "</select>";
dbms_free_result($result);
echo "</form>";

echo "</td></tr>";
echo"</table>";

echo "<br />";
echo "<form action=host_edit.php method=post>";
echo "<input type=hidden name=host value=$number>";
echo "<input type=submit value=Back />";
echo "</form>";

?>
